use strict;
use warnings;
use utf8;

# このスクリプトはSmart::Argsをベンチマークするコードです

use Smart::Args;
use Benchmark qw(cmpthese);

sub no_args_func {
    my ($num1, $num2, $num3, $num4) = @_;
    return $num1 + $num2 + $num3 + $num4;
}

sub args_func {
    args_pos my $num1 => 'Num',
             my $num2 => 'Num',
             my $num3 => 'Num',
             my $num4 => 'Num';

    return $num1 + $num2 + $num3 + $num4;
}

cmpthese(100000, {
    no_args => sub {
        no_args_func(100, 200, 300, 400);
    },
    args => sub {
        args_func(100, 200, 300, 400);
    },
});
